import * as React from "react";
import { IZoomPanSettings, TSetZoomPanSettings } from "../utils/zoomAndPan";
import { GraphCanvasEventProps, GraphEdgeEventProps, GraphNodeEventProps, GraphPortEventProps, ICanvasData, TSetData } from "./Graph.interface";
export interface IGraphProps extends Partial<GraphNodeEventProps>, Partial<GraphEdgeEventProps>, Partial<GraphPortEventProps>, Partial<GraphCanvasEventProps> {
    style?: React.CSSProperties;
    data: ICanvasData;
    setData?: TSetData;
    zoomPanSettings?: IZoomPanSettings;
    setPanZoomPanSettings?: TSetZoomPanSettings;
    isNodeDraggingDisabled?: boolean;
    isNodeResizeDisabled?: boolean;
    isClickNodeToSelectDisabled?: boolean;
    isPropsAPIDisabled?: boolean;
    isPanDisabled?: boolean;
    isMultiSelectDisabled?: boolean;
    isConnectDisabled?: boolean;
    isSidePanelDisabled?: boolean;
    isAutoFitDisabled?: boolean;
    isKeyboardEventsDisabled?: boolean;
    isCanvasFocusDisabled?: boolean;
    isAddingNodeDisabled?: boolean;
    isScrollDisabled?: boolean;
    svgRef?: React.RefObject<SVGSVGElement>;
}
export declare const Graph: React.FunctionComponent<IGraphProps>;
