// Generated by dts-bundle v0.7.3
// Dependencies for this module:
//   ../react

declare module 'index' {
    export * from "index/components";
    export * from "index/contexts";
    export * from "index/built-in";
    export * from "index/utils";
    export * from "index/hooks";
}

declare module 'index/components' {
    export * from "index/components/ReactDagEditor";
    export * from "index/components/Graph";
    export * from "index/components/Graph.interface";
    export * from "index/components/RegisterEdge";
    export * from "index/components/RegisterNode";
    export * from "index/components/ContextMenu";
    export * from "index/components/SearchBox";
    export * from "index/components/ItemPanel";
    export * from "index/components/RegisterPanel";
    export * from "index/components/Minimap";
}

declare module 'index/contexts' {
    export * from "index/contexts/GraphConfigContext";
    export * from "index/contexts/PropsAPIContext";
    export * from "index/contexts/ContextMenuConfigContext";
    export * from "index/contexts/PanelContext";
    export * from "index/contexts/ThemeContext";
}

declare module 'index/built-in' {
    export * from "index/built-in/rect";
    export * from "index/built-in/line";
    export * from "index/built-in/defaultPort";
    export * from "index/built-in/withDefaultPortsPosition";
    export * from "index/built-in/defaultClipboard";
    export * from "index/built-in/defaultAnnotation";
    export * from "index/built-in/defaultStorage";
}

declare module 'index/utils' {
    export * from "index/utils/getPortPosition";
    export * from "index/utils/getNodeConfig";
    export * from "index/utils/graphDataUtils";
    export * from "index/utils/transformMatrix";
    export * from "index/utils/zoomAndPan";
    export * from "index/utils/getCurvePathD";
    export * from "index/utils/layout";
    export * from "index/utils/browsers";
}

declare module 'index/hooks' {
    export * from "index/hooks/usePropsAPI";
    export * from "index/hooks/useContextMenuConfigContext";
    export * from "index/hooks/useKeyboardHandlers";
    export * from "index/hooks/useWheelHandlers";
    export * from "index/hooks/useWindowEvent";
    export * from "index/hooks/useContextMenu";
    export * from "index/hooks/useConnectingLine";
    export * from "index/hooks/useClientRect";
    export * from "index/hooks/useTheme";
}

declare module 'index/components/ReactDagEditor' {
    import * as React from "react";
    import { ITheme } from "index/contexts";
    export interface IReactDagEditorProps {
        style?: React.CSSProperties;
        className?: string;
        errorBoundary?: React.ComponentClass | React.FunctionComponent;
        theme?: ITheme;
    }
    export const ReactDagEditor: React.FunctionComponent<IReactDagEditorProps>;
}

declare module 'index/components/Graph' {
    import * as React from "react";
    import { IZoomPanSettings, TSetZoomPanSettings } from "index/utils/zoomAndPan";
    import { GraphCanvasEventProps, GraphEdgeEventProps, GraphNodeEventProps, GraphPortEventProps, ICanvasData, TSetData } from "index/components/Graph.interface";
    export interface IGraphProps extends Partial<GraphNodeEventProps>, Partial<GraphEdgeEventProps>, Partial<GraphPortEventProps>, Partial<GraphCanvasEventProps> {
        style?: React.CSSProperties;
        data: ICanvasData;
        setData?: TSetData;
        zoomPanSettings?: IZoomPanSettings;
        setPanZoomPanSettings?: TSetZoomPanSettings;
        isNodeDraggingDisabled?: boolean;
        isNodeResizeDisabled?: boolean;
        isClickNodeToSelectDisabled?: boolean;
        isPropsAPIDisabled?: boolean;
        isPanDisabled?: boolean;
        isMultiSelectDisabled?: boolean;
        isConnectDisabled?: boolean;
        isSidePanelDisabled?: boolean;
        isAutoFitDisabled?: boolean;
        isKeyboardEventsDisabled?: boolean;
        isCanvasFocusDisabled?: boolean;
        isAddingNodeDisabled?: boolean;
        isScrollDisabled?: boolean;
        svgRef?: React.RefObject<SVGSVGElement>;
    }
    export const Graph: React.FunctionComponent<IGraphProps>;
}

declare module 'index/components/Graph.interface' {
    import { GraphAnnotationEvent, GraphCanvasEvent, GraphEdgeEvent, GraphNodeEvent, GraphPortEvent } from "index/common/GraphEvent.constant";
    export type TSetData = React.Dispatch<React.SetStateAction<ICanvasData>>;
    export interface ICanvasNode {
        shape?: string;
        x: number;
        y: number;
        name?: string;
        id: string;
        state?: GraphNodeState;
        isInSearchResults?: boolean;
        ports?: ICanvasPort[];
        data?: any;
        height?: number;
        width?: number;
    }
    export enum GraphEdgeState {
        default = "default",
        selected = "selected"
    }
    export interface ICanvasEdge {
        shape?: string;
        source: string;
        target: string;
        sourcePortId: string;
        targetPortId: string;
        id: string;
        state?: GraphEdgeState;
    }
    export interface ICanvasPort {
        id: string;
        name: string;
        shape?: string;
        position?: [number, number];
        state?: GraphPortState;
        connectState?: GraphPortConnectState;
        isInputDisabled?: boolean;
        isOutputDisabled?: boolean;
    }
    export interface ICanvasAnnotation {
        shape?: string;
        x: number;
        y: number;
        name?: string;
        id: string;
        state?: GraphNodeState;
        data?: any;
        height?: number;
        width?: number;
    }
    export enum GraphNodeState {
        default = "default",
        activated = "activated",
        selected = "selected",
        editing = "editing"
    }
    export enum GraphPortState {
        default = "default",
        selected = "selected",
        activated = "activated",
        connecting = "connecting"
    }
    export enum GraphPortConnectState {
        connectedAsSource = "connectedAsSource",
        connectedAsTarget = "connectingAsTarget"
    }
    export interface ICanvasData {
        nodes: ICanvasNode[];
        edges: ICanvasEdge[];
        annotations?: ICanvasAnnotation[];
    }
    export type GraphNodeEventProps = Record<GraphNodeEvent, (e: any, node: ICanvasNode) => void>;
    export type GraphEdgeEventProps = Record<GraphEdgeEvent, (e: any, edge: ICanvasEdge) => void>;
    export type GraphPortEventProps = Record<GraphPortEvent, (e: any, node: ICanvasNode, port: ICanvasPort) => void>;
    export type GraphAnnotationEventProps = Record<GraphAnnotationEvent, (e: any, annotation: ICanvasAnnotation) => void>;
    export type GraphCanvasEventProps = Record<GraphCanvasEvent, (e: any) => void>;
}

declare module 'index/components/RegisterEdge' {
    import * as React from "react";
    import { IEdgeConfig } from "index/contexts";
    export interface IRegisterEdgeProps {
        name: string;
        config: IEdgeConfig;
        extend?: string;
    }
    export const RegisterEdge: React.FunctionComponent<IRegisterEdgeProps>;
}

declare module 'index/components/RegisterNode' {
    import * as React from "react";
    import { IRectConfig } from "index/contexts";
    import { ICanvasNode } from "index/components/Graph.interface";
    export interface IRegisterNodeProps {
        name: string;
        config: IRectConfig<ICanvasNode>;
    }
    export const RegisterNode: React.FunctionComponent<IRegisterNodeProps>;
}

declare module 'index/components/ContextMenu' {
    export * from "index/components/ContextMenu/ContextMenu";
    export * from "index/components/ContextMenu/NodeMenu";
    export * from "index/components/ContextMenu/EdgeMenu";
    export * from "index/components/ContextMenu/PortMenu";
    export * from "index/components/ContextMenu/CanvasMenu";
    export * from "index/components/ContextMenu/MultiMenu";
    export * from "index/components/ContextMenu/AnnotationMenu";
}

declare module 'index/components/SearchBox' {
    import * as React from "react";
    import { ICanvasNode } from "index/components/Graph.interface";
    export interface ISearchBoxProps {
        nodeSearchCriteria(searchKey: string, node: ICanvasNode): boolean;
        renderResult?(node: ICanvasNode): React.ReactNode;
    }
    export interface ISearchBoxState {
        searchText: string;
        results: ICanvasNode[];
        selectedIndex: number;
    }
    export const SearchBox: React.FunctionComponent<ISearchBoxProps>;
}

declare module 'index/components/ItemPanel' {
    export * from "index/components/ItemPanel/Item";
    export * from "index/components/ItemPanel/GraphItemPanel";
}

declare module 'index/components/RegisterPanel' {
    import * as React from "react";
    import { IPanelConfig } from "index/contexts";
    export interface IRegisterPanelProps {
        name: string;
        config: IPanelConfig;
    }
    export const RegisterPanel: React.FunctionComponent<IRegisterPanelProps>;
}

declare module 'index/components/Minimap' {
    import * as React from "react";
    interface IMiniMapProps {
        style?: React.CSSProperties;
    }
    export const Minimap: React.FunctionComponent<IMiniMapProps>;
    export {};
}

declare module 'index/contexts/GraphConfigContext' {
    import * as React from "react";
    import { IGraphClipBoard } from "index/built-in/defaultClipboard";
    import { ICanvasAnnotation, ICanvasData, ICanvasEdge, ICanvasNode, ICanvasPort, IGraphProps, TSetData } from "index/components";
    import { ITheme } from "index/contexts/ThemeContext";
    interface IItemConfigArgs<T> {
        model: T;
        graphProps: IGraphProps;
        setData: TSetData;
        theme: ITheme;
    }
    export interface INodeDrawArgs extends IItemConfigArgs<ICanvasNode> {
    }
    export interface IRectConfig<T> {
        portShape?: string;
        getPorts?(args: Omit<INodeDrawArgs, "theme">): ICanvasPort[];
        render(args: IItemConfigArgs<T>): React.ReactNode;
        getStyle?(rect: T, theme: ITheme): React.CSSProperties;
        getMinWidth(rect: T): number;
        getMinHeight(rect: T): number;
    }
    export interface IEdgeDrawArgs extends IItemConfigArgs<ICanvasEdge> {
        x1: number;
        y1: number;
        x2: number;
        y2: number;
    }
    export interface IEdgeConfig {
        render(args: IEdgeDrawArgs): React.ReactNode;
        getStyle?(edge: ICanvasEdge, theme: ITheme): React.CSSProperties;
    }
    export interface IPortDrawArgs extends IItemConfigArgs<ICanvasPort> {
        data: ICanvasData;
        parentNode: ICanvasNode;
        x: number;
        y: number;
    }
    export interface IPortConfig {
        render(args: IPortDrawArgs): React.ReactNode;
        getIsConnectable(port: ICanvasPort, data: ICanvasData): boolean | undefined;
        getStyle?(port: ICanvasPort, data: ICanvasData, theme: ITheme): React.CSSProperties;
    }
    export interface IGraphConfig {
        registerNode(name: string, config: IRectConfig<ICanvasNode>): void;
        getNodeConfigByName(name: string): IRectConfig<ICanvasNode> | void;
        registerEdge(name: string, config: IEdgeConfig): void;
        getEdgeConfigByName(name: string): IEdgeConfig | void;
        registerPort(name: string, config: IPortConfig): void;
        getPortConfigByName(name: string): IPortConfig | void;
        registerAnnotation(name: string, config: IRectConfig<ICanvasAnnotation>): void;
        getAnnotationConfigByName(name: string): IRectConfig<ICanvasAnnotation> | void;
        registerClipboard(clipboard: IGraphClipBoard): void;
        getClipboard(): IGraphClipBoard;
    }
    export class GraphConfig implements IGraphConfig {
        registerNode(name: string, config: IRectConfig<ICanvasNode>): void;
        getNodeConfigByName(name: string): IRectConfig<ICanvasNode> | void;
        registerEdge(name: string, config: IEdgeConfig): void;
        getEdgeConfigByName(name: string): IEdgeConfig | void;
        registerPort(name: string, config: IPortConfig): void;
        getPortConfigByName(name: string): IPortConfig | void;
        registerAnnotation(name: string, config: IRectConfig<ICanvasAnnotation>): void;
        getAnnotationConfigByName(name: string): IRectConfig<ICanvasAnnotation> | void;
        registerClipboard(clipboard: IGraphClipBoard): void;
        getClipboard(): IGraphClipBoard;
    }
    export const GraphConfigContext: React.Context<IGraphConfig>;
    export {};
}

declare module 'index/contexts/PropsAPIContext' {
    import * as React from "react";
    import { ICanvasAnnotation, ICanvasData, ICanvasEdge, ICanvasNode, ICanvasPort, TSetData } from "index/components";
    import { IZoomPanSettings, TSetZoomPanSettings } from "index/utils/zoomAndPan";
    import { IGraphConfig } from "index/contexts/GraphConfigContext";
    import { IPanelContext } from "index/contexts/PanelContext";
    export interface IPropsAPI {
        init(_setData: TSetData, _getData: () => ICanvasData, svgRef: React.RefObject<SVGSVGElement>, zoomPanSettings: IZoomPanSettings, setZoomPanSettings: TSetZoomPanSettings, graphConfig: IGraphConfig, panelContext: IPanelContext): void;
        getNodeById(id: string): ICanvasNode | void;
        read(data: ICanvasData): void;
        save(): ICanvasData;
        setData(data: ICanvasData): void;
        getData(): ICanvasData;
        addNode(node: ICanvasNode): void;
        setSelected(nodeId: string): void;
        addEdge(edge: ICanvasEdge): void;
        updateNode(id: string, patch: Partial<ICanvasNode>): ICanvasNode | false;
        deletePort(portId: string, nodeId: string): void;
        addPort<P extends ICanvasPort>(nodeId: string, port: P): void;
        delete(): void;
        zoom(scale: number): void;
        pan(dx: number, dy: number): void;
        resetZoom(): void;
        zoomTo(scale: number): void;
        zoomToFit(): void;
        copy(): void;
        paste(x?: number, y?: number): void;
        addAnnotation(annotation: ICanvasAnnotation): void;
        undo(): void;
        redo(): void;
        markSearchResults(matchesIds: string[]): void;
        openSidePanel(name: string, data?: any): void;
        dismissSidePanel(): void;
        getVisiblePanelName(): string | void;
        scrollIntoView(x: number, y: number): void;
        getBoundaryPoints(): {
            minX: number;
            minY: number;
            maxX: number;
            maxY: number;
        };
    }
    export interface IPropsAPIContext {
        propsAPI: IPropsAPI;
    }
    export class PropsAPI implements IPropsAPI {
        init(_setData: TSetData, _getData: () => ICanvasData, svgRef: React.RefObject<SVGSVGElement>, zoomPanSettings: IZoomPanSettings, setZoomPanSettings: TSetZoomPanSettings, graphConfig: IGraphConfig, panelContext: IPanelContext): void;
        getNodeById(id: string): ICanvasNode | void;
        setData(data: ICanvasData): void;
        read(data: ICanvasData): void;
        getData(): ICanvasData;
        save(): ICanvasData;
        addNode(node: ICanvasNode): void;
        addEdge(edge: ICanvasEdge): void;
        updateNode(id: string, patch: Partial<ICanvasNode>): ICanvasNode | false;
        deletePort(portId: string, nodeId: string): void;
        addPort<P extends ICanvasPort>(nodeId: string, port: P): void;
        setSelected(nodeId: string): void;
        delete(): void;
        zoom(scale: number): void;
        pan(dx: number, dy: number): void;
        resetZoom(): void;
        zoomTo(scale: number): void;
        zoomToFit(): void;
        copy(): void;
        paste(x?: number, y?: number): void;
        addAnnotation(annotation: ICanvasAnnotation): void;
        redo(): void;
        undo(): void;
        markSearchResults(matchesIds: string[]): void;
        openSidePanel(name: string, data?: any): void;
        dismissSidePanel(): void;
        getVisiblePanelName(): string | void;
        scrollIntoView(x: number, y: number): void;
        getBoundaryPoints(): {
            minX: number;
            minY: number;
            maxX: number;
            maxY: number;
        };
    }
    export const PropsAPIContext: React.Context<IPropsAPIContext>;
}

declare module 'index/contexts/ContextMenuConfigContext' {
    import * as React from "react";
    export interface IContextMenuProps {
        className?: string;
        styles?: Partial<React.CSSProperties>;
    }
    export enum MenuType {
        Node = "node",
        Edge = "edge",
        Port = "port",
        Annotation = "annotation",
        Canvas = "canvas",
        Multi = "multi"
    }
    export interface IContextMenuConfig {
        registerContextMenu(props: IContextMenuProps): void;
        registerMenu(element: React.ReactNode, menuType: MenuType): void;
        getMenu(menuType: MenuType): React.ReactNode;
    }
    export class ContextMenuConfig implements IContextMenuConfig {
        registerContextMenu(props: IContextMenuProps): void;
        registerMenu(element: React.ReactNode, menuType: MenuType): void;
        getMenu(menuType: MenuType): React.ReactNode;
    }
    export const ContextMenuConfigContext: React.Context<IContextMenuConfig>;
}

declare module 'index/contexts/PanelContext' {
    import * as React from "react";
    export interface IPanelConfig {
        render(data: any, containerRef: React.RefObject<SVGSVGElement>): React.ReactNode;
        panelDidOpen?(): void;
        panelDidDismiss?(): void;
    }
    export interface IPanelState {
        name?: string;
        data?: any;
    }
    export interface IPanelContext {
        configList: Map<string, IPanelConfig>;
        state: IPanelState;
        setState(state: IPanelState): void;
    }
    export const PanelContext: React.Context<IPanelContext>;
}

declare module 'index/contexts/ThemeContext' {
    import * as React from "react";
    export interface ITheme {
        [key: string]: string;
    }
    export interface IThemeContext {
        theme: ITheme;
        setTheme: React.Dispatch<React.SetStateAction<ITheme>>;
    }
    export const ThemeContext: React.Context<IThemeContext>;
}

declare module 'index/built-in/rect' {
    import { ICanvasNode } from "index/components";
    import { IRectConfig } from "index/contexts";
    export const rect: IRectConfig<ICanvasNode>;
}

declare module 'index/built-in/line' {
    import { IEdgeConfig } from "index/contexts";
    export const line: IEdgeConfig;
}

declare module 'index/built-in/defaultPort' {
    import { IPortConfig } from "index/contexts";
    export const defaultPort: IPortConfig;
}

declare module 'index/built-in/withDefaultPortsPosition' {
    import { ICanvasNode } from "index/components";
    import { IRectConfig } from "index/contexts";
    export const withDefaultPortsPosition: (base: IRectConfig<ICanvasNode>) => IRectConfig<ICanvasNode>;
}

declare module 'index/built-in/defaultClipboard' {
    import { ICanvasData } from "index/components";
    export interface IGraphClipBoard {
        write(data: ICanvasData): void;
        read(): ICanvasData | null;
    }
    export const COPIED_NODE_SPACING = 50;
    export class DefaultClipboard implements IGraphClipBoard {
        constructor(storage: Storage);
        write(data: ICanvasData): void;
        read(): ICanvasData | null;
    }
}

declare module 'index/built-in/defaultAnnotation' {
    import { ICanvasAnnotation } from "index/components";
    import { IRectConfig } from "index/contexts";
    export const defaultAnnotation: IRectConfig<ICanvasAnnotation>;
}

declare module 'index/built-in/defaultStorage' {
    export class DefaultStorage implements Storage {
        get length(): number;
        items: object[];
        constructor();
        key: () => string;
        clear(): void;
        setItem(key: string, data: string): void;
        getItem(key: string): string;
        removeItem(key: string): void;
    }
}

declare module 'index/utils/getPortPosition' {
    import { ICanvasNode, ICanvasPort, IGraphProps } from "index/components";
    import { IGraphConfig } from "index/contexts";
    export const getPortPosition: (node: ICanvasNode, port: ICanvasPort, graphConfig: IGraphConfig, transformMatrix?: [number, number, number, number, number, number] | undefined) => {
        x: number;
        y: number;
    };
    export const getPortPositionByPortId: (node: ICanvasNode, portId: string, graphConfig: IGraphConfig, graphProps: IGraphProps, setData: import("react").Dispatch<import("react").SetStateAction<import("../components").ICanvasData>>, transformMatrix?: [number, number, number, number, number, number] | undefined) => {
        x: number;
        y: number;
    };
}

declare module 'index/utils/getNodeConfig' {
    import { ICanvasNode } from "index/components";
    import { IGraphConfig } from "index/contexts";
    export const getNodeConfig: (node: ICanvasNode, graphConfig: IGraphConfig) => import("../contexts").IRectConfig<ICanvasNode>;
}

declare module 'index/utils/graphDataUtils' {
    import { GraphEdgeState, GraphNodeState, ICanvasAnnotation, ICanvasData, ICanvasEdge, ICanvasNode, ICanvasPort, IGraphProps, TSetData } from "index/components";
    import { IGraphConfig } from "index/contexts";
    export function getEntityById<T extends {
        id: string;
    }>(id: string, data?: T[]): T;
    export const updateNode: (nodeId: string, patch: Partial<ICanvasNode>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const updateAnnotation: (annotationId: string, patch: Partial<ICanvasAnnotation>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const updateEdge: (edgeId: string, patch: Partial<ICanvasEdge>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export function updateEntity<T extends {
        id: string;
    }>(entityId: string, entityType: keyof ICanvasData, patch: Partial<T>, setData: TSetData): void;
    export const moveNode: (nodeId: string, dx: number, dy: number, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const updatePort: (nodeId: string, portId: string, patch: Partial<ICanvasPort>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const getNearestConnectablePort: (node: ICanvasNode, clientX: number, clientY: number, graphConfig: IGraphConfig, graphProps: IGraphProps, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>, transformMatrix: [number, number, number, number, number, number]) => ICanvasPort | undefined;
    export const isConnectable: (graphConfig: IGraphConfig, port?: ICanvasPort | undefined, data?: ICanvasData | undefined) => boolean | undefined;
    export const addEdgeByPosition: (nodes: ICanvasNode[], source: string, sourcePortId: string, clientX: number, clientY: number, graphConfig: IGraphConfig, graphProps: IGraphProps, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>, transformMatrix: [number, number, number, number, number, number]) => void;
    export const addEdge: (edge: ICanvasEdge, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const resetPortsState: (data: ICanvasData) => ICanvasData;
    export const normalizePortsConnectState: (data: ICanvasData) => ICanvasData;
    export const filterSelectedItems: (data: ICanvasData) => ICanvasData;
    export const deleteSelectedItems: (setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const addNode: (node: ICanvasNode, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export const addAnnotation: (annotation: ICanvasAnnotation, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
    export function getSelectedEntityIds<T extends {
        id: string;
        state?: GraphNodeState | GraphEdgeState;
    }>(entities?: T[]): string[];
}

declare module 'index/utils/transformMatrix' {
    import { IZoomPanSettings } from "index/utils/zoomAndPan";
    export const getClientByPoint: (x: number, y: number, transformMatrix?: [number, number, number, number, number, number] | undefined) => {
        x: number;
        y: number;
    };
    export const getPointByClient: (x: number, y: number, transformMatrix?: [number, number, number, number, number, number] | undefined) => {
        x: number;
        y: number;
    };
    export const getTransformedPointByRealPoint: (realX: number, realY: number, transformMatrix?: [number, number, number, number, number, number] | undefined) => {
        x: number;
        y: number;
    };
    export const adjustedClientPoint: (x: number, y: number, svgRef: import("react").RefObject<SVGSVGElement>, zoomPanSettings: IZoomPanSettings) => [number, number];
}

declare module 'index/utils/zoomAndPan' {
    import { ICanvasData, ICanvasNode } from "index/components";
    export interface IZoomPanSettings {
        transformMatrix: [number, number, number, number, number, number];
    }
    export type TSetZoomPanSettings = React.Dispatch<React.SetStateAction<IZoomPanSettings>>;
    export const zoomTo: (scale: number, svgRef: import("react").RefObject<SVGSVGElement>, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>) => void;
    export const zoom: (scale: number, svgRef: import("react").RefObject<SVGSVGElement>, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>) => void;
    export const pan: (dx: number, dy: number, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>) => void;
    export const resetZoom: (setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>) => void;
    export const getZoomFitMatrix: (data: ICanvasData, height: number, width: number) => [number, number, number, number, number, number];
    export const zoomToFit: (data: ICanvasData, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>, svgRef: import("react").RefObject<SVGSVGElement>) => void;
    export const scrollIntoView: (x: number, y: number, svgRef: import("react").RefObject<SVGSVGElement>, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>, alwaysScroll?: boolean | undefined) => void;
    export const focusNode: (node: ICanvasNode, svgRef: import("react").RefObject<SVGSVGElement>, zoomAndPanSettings: IZoomPanSettings, setZoomPanSettings: import("react").Dispatch<import("react").SetStateAction<IZoomPanSettings>>) => void;
}

declare module 'index/utils/getCurvePathD' {
    export const getCurvePathD: (x1: number, x2: number, y1: number, y2: number) => string;
}

declare module 'index/utils/layout' {
    import { IRectConfig } from "index/contexts";
    import { IZoomPanSettings } from "index/utils/zoomAndPan";
    export function getRectWidth<T extends {
        width?: number;
    }>(rectConfig: IRectConfig<T>, rect: T): number;
    export function getRectHeight<T extends {
        height?: number;
    }>(rectConfig: IRectConfig<T>, rect: T): number;
    export const getBoundaryPoints: (svgRef: import("react").RefObject<SVGSVGElement>, zoomAndPanSettings: IZoomPanSettings) => {
        minX: number;
        minY: number;
        maxX: number;
        maxY: number;
    };
}

declare module 'index/utils/browsers' {
    export const isMobile: () => boolean;
    enum BrowserType {
        unknown = "unknown",
        edge = "edge",
        edgeChromium = "edgeChromium",
        opera = "opera",
        chrome = "chrome",
        ie = "ie",
        firefox = "firefox",
        safari = "safari"
    }
    global {
        interface Window {
            opr: any;
            chrome: any;
        }
    }
    export const getBrowser: () => BrowserType;
    export const isSupported: () => boolean;
    export {};
}

declare module 'index/hooks/usePropsAPI' {
    import { IPropsAPI } from "index/contexts";
    export const usePropsAPI: () => IPropsAPI;
}

declare module 'index/hooks/useContextMenuConfigContext' {
    import { IContextMenuConfig } from "index/contexts";
    export const useContextMenuConfigContext: () => IContextMenuConfig;
}

declare module 'index/hooks/useKeyboardHandlers' {
    import * as React from "react";
    import { TSetData } from "index/components";
    import { IGraphConfig } from "index/contexts";
    export interface IUseKeyboardHandlersArgs {
        setIsSpaceHeld: React.Dispatch<React.SetStateAction<boolean>>;
        setData: TSetData;
        getGraphConfig(): IGraphConfig;
        getIsCanvasFocused(): boolean;
    }
    export const useKeyboardHandlers: (args: IUseKeyboardHandlersArgs) => void;
}

declare module 'index/hooks/useWheelHandlers' {
    import * as React from "react";
    import { TSetZoomPanSettings } from "index/utils/zoomAndPan";
    interface IUseWheelHandlersOptions {
        svgRef: React.RefObject<SVGSVGElement>;
        setZoomPanSettings: TSetZoomPanSettings;
        getIsCanvasFocused(): boolean;
    }
    export const useWheelHandlers: (options: IUseWheelHandlersOptions) => void;
    export {};
}

declare module 'index/hooks/useWindowEvent' {
    export const useWindowEvent: (event: "keydown" | "keyup" | "wheel", callback: EventListener, options?: boolean | AddEventListenerOptions | undefined) => void;
}

declare module 'index/hooks/useContextMenu' {
    import * as React from "react";
    import { MenuType } from "index/contexts";
    export const useContextMenu: (isVisibleContextMenu: boolean, clientX: number, clientY: number) => [React.ReactNode, (value: React.SetStateAction<MenuType>) => void, boolean, (value: React.SetStateAction<boolean>) => void, ((node: any) => void) | null, {
        left: number | undefined;
        top: number | undefined;
        right: number | undefined;
        bottom: number | undefined;
    }];
}

declare module 'index/hooks/useConnectingLine' {
    import * as React from "react";
    import { IConnectingLine } from "index/components/ConnectingLine";
    export const useConnectingLine: () => [IConnectingLine, React.Dispatch<React.SetStateAction<IConnectingLine>>];
}

declare module 'index/hooks/useClientRect' {
    export const useClientRect: () => [any, ((node: any) => void) | null];
}

declare module 'index/hooks/useTheme' {
    import { IThemeContext } from "index/contexts";
    export const useTheme: () => IThemeContext;
}

declare module 'index/common/GraphEvent.constant' {
    export enum GraphNodeEvent {
        onNodeClick = "onNodeClick",
        onNodeDoubleClick = "onNodeDoubleClick",
        onNodeMouseDown = "onNodeMouseDown",
        onNodeMouseUp = "onNodeMouseUp",
        onNodeMouseEnter = "onNodeMouseEnter",
        onNodeMouseLeave = "onNodeMouseLeave",
        onNodeMouseOver = "onNodeMouseOver",
        onNodeMouseOut = "onNodeMouseOut",
        onNodeMouseMove = "onNodeMouseMove",
        onNodeContextMenu = "onNodeContextMenu",
        onNodeDrag = "onNodeDrag",
        onNodeDragStart = "onNodeDragStart",
        onNodeDragEnd = "onNodeDragEnd"
    }
    export enum GraphEdgeEvent {
        onEdgeClick = "onEdgeClick",
        onEdgeDoubleClick = "onEdgeDoubleClick",
        onEdgeMouseEnter = "onEdgeMouseEnter",
        onEdgeMouseLeave = "onEdgeMouseLeave",
        onEdgeMouseOver = "onEdgeMouseOver",
        onEdgeMouseOut = "onEdgeMouseOut",
        onEdgeMouseMove = "onEdgeMouseMove",
        onEdgeMouseDown = "onEdgeMouseDown",
        onEdgeMouseUp = "onEdgeMouseUp",
        onEdgeContextMenu = "onEdgeContextMenu"
    }
    export enum GraphPortEvent {
        onPortClick = "onPortClick",
        onPortDoubleClick = "onPortDoubleClick",
        onPortMouseDown = "onPortMouseDown",
        onPortMouseUp = "onPortMouseUp",
        onPortMouseEnter = "onPortMouseEnter",
        onPortMouseLeave = "onPortMouseLeave",
        onPortMouseOver = "onPortMouseOver",
        onPortMouseOut = "onPortMouseOut",
        onPortMouseMove = "onPortMouseMove",
        onPortContextMenu = "onPortContextMenu"
    }
    export enum GraphCanvasEvent {
        onCanvasClick = "onCanvasClick",
        onCanvasDoubleClick = "onCanvasDoubleClick",
        onCanvasMouseDown = "onCanvasMouseDown",
        onCanvasMouseUp = "onCanvasMouseUp",
        onCanvasMouseEnter = "onCanvasMouseEnter",
        onCanvasMouseLeave = "onCanvasMouseLeave",
        onCanvasMouseOver = "onCanvasMouseOver",
        onCanvasMouseOut = "onCanvasMouseOut",
        onCanvasMouseMove = "onCanvasMouseMove",
        onCanvasContextMenu = "onCanvasContextMenu",
        onCanvasDragStart = "onCanvasDragStart",
        onCanvasDrag = "onCanvasDrag",
        onCanvasDragEnd = "onCanvasDragEnd"
    }
    export enum GraphAnnotationEvent {
        onAnnotationClick = "onAnnotationClick",
        onAnnotationDoubleClick = "onAnnotationDoubleClick",
        onAnnotationMouseDown = "onAnnotationMouseDown",
        onAnnotationMouseUp = "onAnnotationMouseUp",
        onAnnotationMouseEnter = "onAnnotationMouseEnter",
        onAnnotationMouseLeave = "onAnnotationMouseLeave",
        onAnnotationMouseOver = "onAnnotationMouseOver",
        onAnnotationMouseOut = "onAnnotationMouseOut",
        onAnnotationMouseMove = "onAnnotationMouseMove",
        onAnnotationContextMenu = "onAnnotationContextMenu"
    }
}

declare module 'index/components/ContextMenu/ContextMenu' {
    import * as React from "react";
    import { IContextMenuProps } from "index/contexts";
    export const ContextMenu: React.FunctionComponent<IContextMenuProps>;
}

declare module 'index/components/ContextMenu/NodeMenu' {
    import * as React from "react";
    export const NodeMenu: React.FunctionComponent;
}

declare module 'index/components/ContextMenu/EdgeMenu' {
    import * as React from "react";
    export const EdgeMenu: React.FunctionComponent;
}

declare module 'index/components/ContextMenu/PortMenu' {
    import * as React from "react";
    export const PortMenu: React.FunctionComponent;
}

declare module 'index/components/ContextMenu/CanvasMenu' {
    import * as React from "react";
    export const CanvasMenu: React.FunctionComponent;
}

declare module 'index/components/ContextMenu/MultiMenu' {
    import * as React from "react";
    export const MultiMenu: React.FunctionComponent;
}

declare module 'index/components/ContextMenu/AnnotationMenu' {
    import * as React from "react";
    export const AnnotationMenu: React.FunctionComponent;
}

declare module 'index/components/ItemPanel/Item' {
    import * as React from "react";
    import { ICanvasNode } from "index/components/Graph.interface";
    interface IProps {
        style?: React.CSSProperties;
        className?: string;
        model: Partial<ICanvasNode>;
        shape?: string;
    }
    export const Item: React.FunctionComponent<IProps>;
    export {};
}

declare module 'index/components/ItemPanel/GraphItemPanel' {
    import * as React from "react";
    import { IZoomPanSettings } from "index/utils";
    import { IGraphProps } from "index/components/Graph";
    import { TSetData } from "index/components/Graph.interface";
    interface IProps {
        visible: boolean;
        setData: TSetData;
        graphProps: IGraphProps;
        graphSvgRef: React.RefObject<SVGSVGElement>;
        zoomPanSettings: IZoomPanSettings;
    }
    export const GraphItemPanel: React.FunctionComponent<IProps>;
    export {};
}

declare module 'index/components/ConnectingLine' {
    import * as React from "react";
    export interface IConnectingLine {
        x1: number;
        y1: number;
        x2: number;
        y2: number;
        visible: boolean;
    }
    interface IProps {
        connectingLine: IConnectingLine;
        autoAttachLine: IConnectingLine;
        styles?: React.CSSProperties;
    }
    export const ConnectingLine: React.FunctionComponent<IProps>;
    export {};
}

