import { GraphEdgeState, GraphNodeState, ICanvasAnnotation, ICanvasData, ICanvasEdge, ICanvasNode, ICanvasPort, IGraphProps, TSetData } from "../components";
import { IGraphConfig } from "../contexts";
export declare function getEntityById<T extends {
    id: string;
}>(id: string, data?: T[]): T;
export declare const updateNode: (nodeId: string, patch: Partial<ICanvasNode>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const updateAnnotation: (annotationId: string, patch: Partial<ICanvasAnnotation>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const updateEdge: (edgeId: string, patch: Partial<ICanvasEdge>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare function updateEntity<T extends {
    id: string;
}>(entityId: string, entityType: keyof ICanvasData, patch: Partial<T>, setData: TSetData): void;
export declare const moveNode: (nodeId: string, dx: number, dy: number, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const updatePort: (nodeId: string, portId: string, patch: Partial<ICanvasPort>, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const getNearestConnectablePort: (node: ICanvasNode, clientX: number, clientY: number, graphConfig: IGraphConfig, graphProps: IGraphProps, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>, transformMatrix: [number, number, number, number, number, number]) => ICanvasPort | undefined;
export declare const isConnectable: (graphConfig: IGraphConfig, port?: ICanvasPort | undefined, data?: ICanvasData | undefined) => boolean | undefined;
export declare const addEdgeByPosition: (nodes: ICanvasNode[], source: string, sourcePortId: string, clientX: number, clientY: number, graphConfig: IGraphConfig, graphProps: IGraphProps, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>, transformMatrix: [number, number, number, number, number, number]) => void;
export declare const addEdge: (edge: ICanvasEdge, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const resetPortsState: (data: ICanvasData) => ICanvasData;
export declare const normalizePortsConnectState: (data: ICanvasData) => ICanvasData;
export declare const filterSelectedItems: (data: ICanvasData) => ICanvasData;
export declare const deleteSelectedItems: (setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const addNode: (node: ICanvasNode, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare const addAnnotation: (annotation: ICanvasAnnotation, setData: import("react").Dispatch<import("react").SetStateAction<ICanvasData>>) => void;
export declare function getSelectedEntityIds<T extends {
    id: string;
    state?: GraphNodeState | GraphEdgeState;
}>(entities?: T[]): string[];
